// Code generated by mockery v2.40.1. DO NOT EDIT.

package mocks

import (
	context "context"
	http "net/http"

	mock "github.com/stretchr/testify/mock"

	ubiquity "gitlab.com/Blockdaemon/ubiquity/ubiquity-go-client/v1/pkg/client"
)

// FeeEstimatorAPI is an autogenerated mock type for the FeeEstimatorAPI type
type FeeEstimatorAPI struct {
	mock.Mock
}

type FeeEstimatorAPI_Expecter struct {
	mock *mock.Mock
}

func (_m *FeeEstimatorAPI) EXPECT() *FeeEstimatorAPI_Expecter {
	return &FeeEstimatorAPI_Expecter{mock: &_m.Mock}
}

// GetFeeEstimate provides a mock function with given fields: ctx, protocol, network
func (_m *FeeEstimatorAPI) GetFeeEstimate(ctx context.Context, protocol string, network string) ubiquity.ApiGetFeeEstimateRequest {
	ret := _m.Called(ctx, protocol, network)

	if len(ret) == 0 {
		panic("no return value specified for GetFeeEstimate")
	}

	var r0 ubiquity.ApiGetFeeEstimateRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string) ubiquity.ApiGetFeeEstimateRequest); ok {
		r0 = rf(ctx, protocol, network)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetFeeEstimateRequest)
	}

	return r0
}

// FeeEstimatorAPI_GetFeeEstimate_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetFeeEstimate'
type FeeEstimatorAPI_GetFeeEstimate_Call struct {
	*mock.Call
}

// GetFeeEstimate is a helper method to define mock.On call
//   - ctx context.Context
//   - protocol string
//   - network string
func (_e *FeeEstimatorAPI_Expecter) GetFeeEstimate(ctx interface{}, protocol interface{}, network interface{}) *FeeEstimatorAPI_GetFeeEstimate_Call {
	return &FeeEstimatorAPI_GetFeeEstimate_Call{Call: _e.mock.On("GetFeeEstimate", ctx, protocol, network)}
}

func (_c *FeeEstimatorAPI_GetFeeEstimate_Call) Run(run func(ctx context.Context, protocol string, network string)) *FeeEstimatorAPI_GetFeeEstimate_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(string), args[2].(string))
	})
	return _c
}

func (_c *FeeEstimatorAPI_GetFeeEstimate_Call) Return(_a0 ubiquity.ApiGetFeeEstimateRequest) *FeeEstimatorAPI_GetFeeEstimate_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *FeeEstimatorAPI_GetFeeEstimate_Call) RunAndReturn(run func(context.Context, string, string) ubiquity.ApiGetFeeEstimateRequest) *FeeEstimatorAPI_GetFeeEstimate_Call {
	_c.Call.Return(run)
	return _c
}

// GetFeeEstimateExecute provides a mock function with given fields: r
func (_m *FeeEstimatorAPI) GetFeeEstimateExecute(r ubiquity.ApiGetFeeEstimateRequest) (ubiquity.InlineResponse200, *http.Response, error) {
	ret := _m.Called(r)

	if len(ret) == 0 {
		panic("no return value specified for GetFeeEstimateExecute")
	}

	var r0 ubiquity.InlineResponse200
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetFeeEstimateRequest) (ubiquity.InlineResponse200, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetFeeEstimateRequest) ubiquity.InlineResponse200); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.InlineResponse200)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetFeeEstimateRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetFeeEstimateRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// FeeEstimatorAPI_GetFeeEstimateExecute_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'GetFeeEstimateExecute'
type FeeEstimatorAPI_GetFeeEstimateExecute_Call struct {
	*mock.Call
}

// GetFeeEstimateExecute is a helper method to define mock.On call
//   - r ubiquity.ApiGetFeeEstimateRequest
func (_e *FeeEstimatorAPI_Expecter) GetFeeEstimateExecute(r interface{}) *FeeEstimatorAPI_GetFeeEstimateExecute_Call {
	return &FeeEstimatorAPI_GetFeeEstimateExecute_Call{Call: _e.mock.On("GetFeeEstimateExecute", r)}
}

func (_c *FeeEstimatorAPI_GetFeeEstimateExecute_Call) Run(run func(r ubiquity.ApiGetFeeEstimateRequest)) *FeeEstimatorAPI_GetFeeEstimateExecute_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(ubiquity.ApiGetFeeEstimateRequest))
	})
	return _c
}

func (_c *FeeEstimatorAPI_GetFeeEstimateExecute_Call) Return(_a0 ubiquity.InlineResponse200, _a1 *http.Response, _a2 error) *FeeEstimatorAPI_GetFeeEstimateExecute_Call {
	_c.Call.Return(_a0, _a1, _a2)
	return _c
}

func (_c *FeeEstimatorAPI_GetFeeEstimateExecute_Call) RunAndReturn(run func(ubiquity.ApiGetFeeEstimateRequest) (ubiquity.InlineResponse200, *http.Response, error)) *FeeEstimatorAPI_GetFeeEstimateExecute_Call {
	_c.Call.Return(run)
	return _c
}

// NewFeeEstimatorAPI creates a new instance of FeeEstimatorAPI. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewFeeEstimatorAPI(t interface {
	mock.TestingT
	Cleanup(func())
}) *FeeEstimatorAPI {
	mock := &FeeEstimatorAPI{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
